#!/usr/local/bin/perl

# first argument holds location of config file
# read in the SMS number to forward mail-header
$number = "";
$logfile = "";
open(CONFIG, "$ARGV[0]") || die "config file ($ARGV[1]) not found.\n";
($dummy,$number) = split("=", <CONFIG>);
if (substr($number, length($number)-1,1) !~ "\d") {
  # remove trailing newline
  $number = substr($number, 0, length($number)-1);
};
($dummy,$logfile) = split("=", <CONFIG>);


# parse Mail for FROM and SUBJECT lines
$from = "";
$fromalias = "";
$subject = "";
while (<STDIN>) {
  if (($_ =~ /^From: (.+)$/i) && ($from eq "")) {
    $from = lc $1; 
  };
  if (($_ =~ /^Subject: (.+)$/) && ($subject eq "")) {
    $subject = $1; 
  };
};


# start entry in logfile
open (LOGFILE, ">>$logfile");
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
$mon++;
print LOGFILE "$mday.$mon.$year $hour:$min:$sec received new mail from $from\n";
print LOGFILE "  Subject: $subject\n";


# check if from-adress is whished in config-file
$ok = 0;
while (<CONFIG>) {
  ($type,$entry) = split("=", $_);
  if (substr($entry, length($entry)-1,1) =~ '\n') {
    # remove trailing newline
    $entry = substr($entry, 0, length($entry)-1);
  };
  $type = lc $type;

  if ($type eq 'include') {
    if ($entry =~ '^\s*\*\s*$') {
      # every mail address is allowed
      $ok = 1;
      print LOGFILE "  all email-addresses are included\n";
    } elsif ($entry =~ '^\s*$') { 
      # no entry -> don't compare
    } else {
      # compare e-mail address
      ($email,$alias) = split(",", $entry);
      $email = lc $email;
      if ($from =~ $email) {
        $ok = 1;
        $fromalias = $alias;
        print LOGIFLE "  this address is included, alias is $alias\n";        
      } else {
        # not matched
      }
    }
  } elsif ($type eq 'exclude') {
    if ($entry =~ '^\s*\*\s*$') {
      # no mail address is allowed
      $ok = 0;
      print LOGFILE "  all email-addresses are excluded\n";
      goto end_compare;
    } elsif ($entry =~ '^\s*$') { 
      # no entry -> don't compare
    } else {
      # compare e-mail address
      ($email,$alias) = split(",", $entry);
      $email = lc $email;
      if ($from =~ $email) {
        $ok = 0;
        print LOGFILE "  this address is excluded\n";
        goto end_compare;        
      } else {
      }
    }
  } else {
    #ignore this line
  };  

};

end_compare:
if ($ok == 1) {
  if ($fromalias ne '') {
    $from = $fromalias;
  };
  print LOGFILE "  try to send message to $number from $from\n";
} else {
  print LOGFILE "  don't send SMS message\n";
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
  $mon++; 
  print LOGFILE "  ended entry $mday.$mon.$year $hour:$min:$sec\n\n";
  close LOGFILE;
  exit;
};


# send message
  use LWP::UserAgent;
  $ua = new LWP::UserAgent;

#  my $req = new HTTP::Request 'POST','http://www.swisscom.com/cgi-bin/msgc/send.pl';
  my $req = new HTTP::Request 'POST','http://www.mtn.co.za/send/sms.html';
  $req->content_type('application/x-www-form-urlencoded');
  $content = "";
  if ($fromalias ne '') {
    $content="intlPrefix=+4179&TEL=$number&OK&MESSAGE=$from:$subject";
    #$content="msgtype=sms&lang=d&number=$number&message=$from: $subject";
  } else {
    $content="intlPrefix=+4179&TEL=$number&OK&MESSAGE=mail from $from:$subject";
    #$content="msgtype=sms&lang=d&number=$number&message=mail from $from: $subject";
  };

  $content =~ s/ /\+/g;
  $req->content($content);
  $req->referer('http://www.mtn.co.za/regulars/sms/text.html');
  my $res = $ua->request($req);

  $result = $res->as_string;
  $result =~ s/\n/ /g;

#  if ($result =~ '^.*ID:\s+([-\d]+) <br>.+Status:\s+(.*) <Br>.*$') {
  if ($result =~ '^.*Your message was sent successfully.*This telephone has been sent (\d+) message.*$') {
    #print LOGFILE "  SMS Gateway ID: $1, Status: $2\n";
    print LOGFILE "  SMS Gateway, Message number $1 on this day\n";
  } elsif ($result =~ '^.*Quota exceeded.*only (\d+) message.*$' ) {
    print LOGFILE "  Quota of $1 messages per day to this number exceeded.\n";
  } else {
    print LOGFILE "  Response from SMS Gateway not understood.\n";
  };

  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
  $mon++;
  print LOGFILE "  ended entry $mday.$mon.$year $hour:$min:$sec\n\n";
  close LOGFILE;












